package com.gx.obe.util.pdf;

import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

import com.itextpdf.text.Document;
import com.itextpdf.text.DocumentException;
import com.itextpdf.text.pdf.PdfCopy;
import com.itextpdf.text.pdf.PdfImportedPage;
import com.itextpdf.text.pdf.PdfReader;


public class MergerPDFUtils {
	
	public static void main(String[] args) throws Exception {
		List<File> fileList = new ArrayList<File>();
		fileList.add(new File("T/报价得分表.pdf"));
		fileList.add(new File("T/报价得分表－01.pdf"));
		fileList.add(new File("T/单报价开标记录表－01.pdf"));
		fileList.add(new File("T/分项评分汇总表 - 01.pdf"));
		fileList.add(new File("T/工作方案评分标准明细表.pdf"));
		fileList.add(new File("T/郭永荣newExpertToNote.pdf"));
		fileList.add(new File("T/开标材料2020.02.11-北园.pdf"));
		fileList.add(new File("T/评标报告测试模板.pdf"));
		fileList.add(new File("T/投标人业绩明细表.pdf"));
		fileList.add(new File("T/响应性评审标准汇总表.pdf"));
		fileList.add(new File("T/项目管理机构评分标明细表.pdf"));		
		try {
			mergerPDF(fileList, "T/zhangsanpdf.pdf");
		} catch (IOException | DocumentException e) {
			e.printStackTrace();
		}
	}
 
	/**
	 * @param fileList 要合并的文件
	 * @param pdfFileName 文件生成的位置名称
	 * @throws IOException
	 * @throws DocumentException
	 */
	public static void mergerPDF(List<File> fileList, String pdfFileName) throws Exception {
		File[] pages = new File[fileList.size()];
		int iSize = 0;
		for(File file : fileList) {
			pages[iSize] = file;
			iSize++;
		}
		File pdffile = new File (pdfFileName);
		if (!pdffile.exists()) {
			pdffile.getParentFile().mkdirs();
			pdffile.createNewFile();
		}else {
			pdffile.delete();
		}
		if (pages.length < 1) {
			return;
		}
		Document document = new Document(new PdfReader(((File) pages[0]).getAbsolutePath()).getPageSize(1));
		PdfCopy copy = new PdfCopy(document, new FileOutputStream(pdffile));
		document.open();
		for (int i = 0; i < pages.length; i++) {
			PdfReader reader = new PdfReader((pages[i]).getAbsolutePath());
			int num = reader.getNumberOfPages();
			for (int j = 1; j <= num; j++) {
				document.newPage();
				PdfImportedPage page = copy.getImportedPage(reader, j);
				copy.addPage(page);
			}
		}
		document.close();
	}
	

	
	
}
