package com.gx.obe.util.thread;

import java.util.Calendar;
import java.util.Date;

/**
 * @Description: 时间倒计时线程
 * @author guoyr
 */
public class CountTimeThread implements Runnable{
	private long startTimes = 0;
	private final Calendar markCalendar = Calendar.getInstance();
	private Thread thread = null;
	private CountTime countTime;
	private Date startTime;
	private Date targetTime;
	boolean isChangeBackground = false;
	long hour = 0;
	long minute = 0;
	long second = 0;
	long day = 0;
	
	public CountTimeThread(Date startTime, Date targetTime, CountTime countTime){
		this.startTime = startTime;
		this.targetTime = targetTime;
		this.countTime = countTime;
	}
	public void start(){
		if(null != targetTime){
			thread = new Thread(this);
			thread.setName("开标倒计时线程");
			thread.start();
		}
	}
	
	public void stop(){
		thread = null;
	}
	public void run() {
		startTimes = startTime.getTime();
		String[]countDownTimeStr = new String[countTime.timeLength];//{"0", "0", "0", "0", "0", "0", "0", "0"};
		int tountDownTimes = countDownTimeStr.length;
		while(null != thread){
			long countTimes = targetTime.getTime() - (startTimes + (Calendar.getInstance().getTimeInMillis() - markCalendar.getTimeInMillis()));
			if(countTimes < 1000){
				countTime.countTime(0, 0, 0, 0);
				for(int i = 0; i < countDownTimeStr.length; i++){
					countDownTimeStr[i] = "0";
				}
				countTime.countTime(countDownTimeStr);
				//时间到了执行
				countTime.finish();
				break;
			}else {
				countTimes /= 1000;
				if (countTimes < 60) {
					minute = 0;
					second = countTimes;
				}else if (countTimes < 3600) {
					hour = 0;
					minute = countTimes / 60;
					second = countTimes % 60;
				}else if (countTimes < 86400) {
					hour = countTimes / 3600;
					minute = (countTimes - hour * 3600) / 60;
					second = (countTimes - hour * 3600) % 60;
				}else {
					day = countTimes / 86400;
					hour = (countTimes - day * 86400) / 3600;
					minute = (countTimes - day * 86400 - hour * 3600) / 60;
					second = (countTimes - day * 86400 - hour * 3600) % 60;
				}
				countTime.countTime(day, hour, minute, second);
				if(countTime.timeLength > 6){
					
				}
				if(day > 0){
					if(countTime.timeLength > 5){
						countDownTimeStr[tountDownTimes-6] = "8";
						countDownTimeStr[tountDownTimes-5] = "8";
					}
				}else {
					if(countTime.timeLength > 5){
						if(hour > 9){
							countDownTimeStr[tountDownTimes-6] = (hour+"").substring(0,1);
							countDownTimeStr[tountDownTimes-5] = (hour+"").substring(1);
						}else {
							countDownTimeStr[tountDownTimes-6] = "0";
							countDownTimeStr[tountDownTimes-5] = hour+"";
						}
					}
				}
				if(countTime.timeLength > 3){
					if(minute > 9){
						countDownTimeStr[tountDownTimes-4] = (minute+"").substring(0,1);
						countDownTimeStr[tountDownTimes-3] = (minute+"").substring(1);
					}else {
						countDownTimeStr[tountDownTimes-4] = "0";
						countDownTimeStr[tountDownTimes-3] = minute+"";
					}
				}
				if(second > 9){
					countDownTimeStr[tountDownTimes-2] = (second+"").substring(0,1);
					countDownTimeStr[tountDownTimes-1] = (second+"").substring(1);
				}else {
					countDownTimeStr[tountDownTimes-2] = "0";
					countDownTimeStr[tountDownTimes-1] = second+"";
				}
				countTime.countTime(countDownTimeStr);
//				System.out.println("day : " + day + "  hour:" + hour +"  minute:" + minute +"  second:" + second);
			}
			try {
				Thread.sleep(1000);
			} catch (InterruptedException e) {
			}
		}
	}
	public static abstract class CountTime{
		private int timeLength = 6;
		public CountTime(){
			
		}
		public CountTime(int timeLength){
			if(timeLength > 1 && timeLength < 7){
				if(timeLength % 2 != 0){
					timeLength += 1;
				}
				this.timeLength = timeLength;
			}
		}
		public void countTime(long day, long hour, long minute, long second){};
		public void countTime(String[] countDownTime){};
		public void finish(){};
		
	}
}
