package com.gx.obe.util.utils;

import java.math.BigDecimal;
import java.text.DecimalFormat;

public class DecimalCxwUtils {
	
	private static final DecimalFormat twoDecimalPlaces = new DecimalFormat("########0.##");
	private static final DecimalFormat fourDecimalPlaces = new DecimalFormat("########0.####");
	
	/**
	 * @Description: 加
	 * @author chenxw
	 * @param d1
	 * @param d2
	 * @return
	 */
	public static BigDecimal add(BigDecimal d1, BigDecimal d2) {
		if (null == d1) {
			return d2;
		}
		if (null == d2) {
			return d1;
		}
		return d1.add(d2);
	}
	
	public static BigDecimal abs(BigDecimal d) {
		if (null == d) {
			return null;
		}
		return d.abs();
	}
	
	/**
	 * @Description: 减
	 * @author chenxw
	 * @param d1
	 * @param d2
	 * @return
	 */
	public static BigDecimal subtract(BigDecimal d1, BigDecimal d2) {
		if (null == d1) {
			return null;
		}
		if (null == d2) {
			return d1;
		}
		return d1.subtract(d2);
	}
	
	/**
	 * @Description: 乘
	 * @author chenxw
	 * @param d1
	 * @param d2
	 * @return
	 */
	public static BigDecimal multiply(BigDecimal d1, BigDecimal d2) {
		if (null == d1 || null == d2) {
			return null;
		}
		return d1.multiply(d2);
	}
	
	/**
	 * @Description: 除
	 * @author chenxw
	 * @param d1
	 * @param d2
	 * @return
	 */
	public static BigDecimal divide(BigDecimal d1, BigDecimal d2) {
		if (null == d1 || compareTo(d2, BigDecimal.ZERO) == 0) {
			return null;
		}
		return d1.divide(d2, 10, BigDecimal.ROUND_HALF_UP);
	}
	
	/**
	 * @Description: 比较
	 * @author chenxw
	 * @param d1
	 * @param d2
	 * @return
	 */
	public static int compareTo(BigDecimal d1, BigDecimal d2) {
		if (null == d1) {
			d1 = BigDecimal.ZERO;
		}
		if (null == d2) {
			d2 = BigDecimal.ZERO;
		}
		return d1.compareTo(d2);
	}
	
	/**
	 * @Description: 设置小数位数
	 * @author chenxw
	 * @param d
	 * @param scale
	 * @return
	 */
	public static BigDecimal setScale(BigDecimal d, int scale) {
		if (null == d) {
			return null;
		}
		if (scale < 0) {
			scale = 0;
		}
		return d.setScale(scale, BigDecimal.ROUND_HALF_UP);
	}
	
	public static String twoFormat(BigDecimal d) {
		d = setScale(d, 2);
		if (null == d) {
			return "";
		}
		return twoDecimalPlaces.format(d);
	}
	
	public static String fourFormat(BigDecimal d) {
		d = setScale(d, 4);
		if (null == d) {
			return "";
		}
		return fourDecimalPlaces.format(d);
	}
	
}
