package com.gx.obe.util.utils;

import java.util.Arrays;
import java.util.function.Function;

/**
 * @Description: key
 * @author chenxw
 */
public class Keys {
	
	private final Object[] keys;
	
	public Keys(Object... keys) {
		this.keys = keys;
	}
	
	public static Keys of(Object... ks) {
		return new Keys(ks);
	}
	
	@SafeVarargs
	public static <T> Function<T, Keys> fun(Function<T, Object>... functionKeys) {
		return t -> new Keys(Arrays.stream(functionKeys).map(f -> f.apply(t)).toArray());
	}
	
	@Override
	public int hashCode() {
		return Arrays.hashCode(keys);
	}
	
	@Override
	public boolean equals(Object obj) {
		if (obj == this) {
			return true;
		}
		if (obj == null) {
			return false;
		}
		if (!(obj instanceof Keys)) {
			return false;
		}
		return Arrays.equals(((Keys) obj).keys, this.keys);
	}
	
	@SuppressWarnings("unchecked")
	public <T> T get(int i) {
		return (T) keys[i];
	}
	
	public <T> T getFirst() {
		return get(0);
	}
	
	public <T> T getSecond() {
		return get(1);
	}
	
	public <T> T getThird() {
		return get(2);
	}
	
}
