package com.gx.obe.util.utils;

import java.util.ArrayList;
import java.util.Comparator;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Set;
import java.util.TreeSet;

public class ListSortUtils<T> {
	
	private int sortCount = 0;
	
	private Map<T, Integer> sortMap = new HashMap<T, Integer>();
	
	private Map<Integer, List<T>> listMap = new HashMap<Integer, List<T>>();
	
	public ListSortUtils(List<T> list, final Comparator<T> c) {
		final Map<T, List<T>> tListMap = new HashMap<T, List<T>>();
		
		Set<T> set = new TreeSet<T>(new Comparator<T>() {
			public int compare(T o1, T o2) {
				if (o1 == o2) {
					return 0;
				}
				int i = c.compare(o1, o2);
				if (i == 0) {
					if (tListMap.containsKey(o2)) {
						tListMap.get(o2).add(o1);
					} else {
						List<T> list = new ArrayList<T>();
						list.add(o1);
						tListMap.put(o2, list);
					}
				}
				return i;
			}
		});
		set.addAll(list);
		
		sortCount = set.size();
		
		int sortNo = 1;
		for (T t : set) {
			List<T> ts = new ArrayList<T>();
			ts.add(t);
			listMap.put(sortNo, ts);
			sortMap.put(t, sortNo);
			if (tListMap.containsKey(t)) {
				for (T t1 : tListMap.get(t)) {
					ts.add(t1);
					sortMap.put(t1, sortNo);
				}
			}
			sortNo++;
		}
		
	}
	
	public int getSortCount() {
		return sortCount;
	}
	
	public List<T> getList(int sortNo) {
		return listMap.get(sortNo);
	}
	
	public int getSortNo(T t) {
		return sortMap.getOrDefault(t, 0);
	}
	
}
