package com.gx.obe.util.utils;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.List;

import org.apache.log4j.Logger;

/**
 * @Description: 
 * @author guoyr
 */
public class MysqlUtils {
	
	private static Logger LOG = Logger.getLogger(MysqlUtils.class);
	
	/**
	 * @Description: 
	 * @author guoyr
	 * @param tool
	 * @param host
	 * @param user
	 * @param pwd
	 * @param dbName
	 * @param sqlPath
	 * @return
	 */
	public static String exec(String tool, String host, String user, String pwd, String dbName, String sqlPath){
		StringBuilder cmd = new StringBuilder();
		
		cmd.append("cmd /c ");
		cmd.append((tool.indexOf(".exe") > 0? tool.substring(0, tool.length()-4): tool ).replace(" ", "\" \""));
		
		// 获得还原(mysql.exe)路径
		cmd.append(" -h").append(host);
		cmd.append(" -u").append(user);
		cmd.append(" -p").append(pwd);
		cmd.append(" ").append(dbName);
		cmd.append(" < ").append(sqlPath.replace(" ", "\" \""));
		
		StringBuilder error = new StringBuilder();
		InputStreamReader inputStream = null;
		BufferedReader bufferReader = null;
		try {
			Runtime rt = Runtime.getRuntime();
//			Process process = rt.exec("cmd /c D:\\Program\" \"Files\\mysql -h192.168.3.44 -uroot -proot dzps_engineer < \"C:\\Program Files\\电子开评标系统\\configuration\\org.eclipse.osgi\\bundles\\54\\1\\.cp\\update.sql\"");
			Process process = rt.exec(cmd.toString());
			inputStream = new InputStreamReader(process.getErrorStream(), "UTF8");
			bufferReader = new BufferedReader(inputStream);
			String line = "";
			while((line = bufferReader.readLine()) != null){
				error.append(line);
			}
		} catch (IOException e){
			LOG.error("mysql数据库Sql脚本执行失败！", e);
			System.out.println("数据库Sql脚本失败！");
		}finally{
			if(null != bufferReader){
				try {
					bufferReader.close();
				} catch (IOException e) {
				}
			}
			if(null != inputStream){
				try {
					inputStream.close();
				} catch (IOException e) {
				}
			}
			if(error.length() > 0){
				LOG.error("错误日志：--------->"+error.toString());
			}else {
				LOG.debug("数据库Sql脚本"+sqlPath+"执行成功！");
			}
		}
		return error.toString();
	}
	
	public static String export(String tool, List<String> params, String host, String user, String pwd, String dbName, List<String> tables, String sqlPath){
		StringBuilder cmd = new StringBuilder();
		
		cmd.append("cmd /c ");
		cmd.append((tool.indexOf(".exe") > 0? tool.substring(0, tool.length()-4): tool ).replace(" ", "\" \""));
		if(null != params && params.size() > 0){
			for(String param : params){
//				cmd.append(" --no-data");
				cmd.append(" ");
				cmd.append(param);
			}
		}
		cmd.append(" -h").append(host);
		cmd.append(" -u").append(user);
		cmd.append(" -p").append(pwd);
		cmd.append(" ").append(dbName);
		
		// 拼接表名
		if(null != tables && tables.size() > 0){
			for(String table : tables){
				if(null != table && !"".equals(table)){
					cmd.append(" ");
					cmd.append(table);
				}
			}
		}
		
		cmd.append(" > ").append(sqlPath.replace(" ", "\" \""));
		
		StringBuilder error = new StringBuilder();
		InputStreamReader inputStream = null;
		BufferedReader bufferReader = null;
		try {
			Runtime rt = Runtime.getRuntime();
//			Process process = rt.exec("cmd /c D:\\Program\" \"Files\\mysql -h192.168.3.44 -uroot -proot dzps_engineer < \"C:\\Program Files\\电子开评标系统\\configuration\\org.eclipse.osgi\\bundles\\54\\1\\.cp\\update.sql\"");
			Process process = rt.exec(cmd.toString());
			inputStream = new InputStreamReader(process.getErrorStream(), "gbk");
			bufferReader = new BufferedReader(inputStream);
			String line = "";
			while((line = bufferReader.readLine()) != null){
				error.append(line);
			}
		} catch (IOException e){
			LOG.error("mysql数据库导出失败！", e);
		}finally{
			if(null != bufferReader){
				try {
					bufferReader.close();
				} catch (IOException e) {
				}
			}
			if(null != inputStream){
				try {
					inputStream.close();
				} catch (IOException e) {
				}
			}
			if(error.length() > 0){
				LOG.error("错误日志：--------->"+error.toString());
			}else {
				LOG.debug("mysql数据库导出成功！");
			}
		}
		return error.toString();
	}
	
}
