package com.gx.obe.util.utils;

import java.io.IOException;
import java.io.InputStream;
import java.net.MalformedURLException;
import java.net.URL;

import org.apache.log4j.Logger;

public class NetWorkUtils {
	
	private static final String WEB_SITE = "https://www.baidu.com";
	private static Logger logger = Logger.getLogger(NetWorkUtils.class);
	
	/**
	 * @Description: 验证本机是否联网
	 * @author guoyr
	 * @return
	 */
	public static boolean isConnNet(){
		boolean isConn = true;
		InputStream in = null;
		try {
			URL url = new URL(WEB_SITE);
			in = url.openStream();
		} catch (MalformedURLException e) {
			isConn = false;
			logger.error("", e);
		} catch (IOException e) {
			isConn = false;
			logger.error("", e);
		}finally{
			if(null != in){
				try {
					in.close();
				} catch (IOException e) {
				}
			}
		}
		return isConn;
	}
	
	/**
	 * @Description: 验证是否连网
	 * @author guoyr
	 * @param urlAddress
	 * @return 
	 */
	public static boolean isConnNet(String urlAddress){
		if(null == urlAddress || "".equals(urlAddress)){
			return false;
		}
		boolean isConn = true;
		InputStream in = null;
		try {
			URL url = new URL(urlAddress);
			in = url.openStream();
		} catch (MalformedURLException e) {
			isConn = false;
			logger.error("", e);
		} catch (IOException e) {
			isConn = false;
			logger.error("", e);
		}finally{
			if(null != in){
				try {
					in.close();
				} catch (IOException e) {
				}
			}
		}
		return isConn;
	}
}
