package com.gx.obe.util.utils;

import java.math.BigDecimal;
import java.math.RoundingMode;
import java.text.NumberFormat;
import java.util.Date;

public class ObjectUtils {

	public static String getObjString(Object obj){
		if(null == obj){
			return "";
		}else {
			return obj.toString();
		}
	}
	
	public static String getObjString(Object obj, String defaultValue){
		if(null == obj || obj.toString().isEmpty()){
			return defaultValue;
		}else {
			return obj.toString();
		}
	}
	
	public static Date getObjDate(Object obj){
		if(null == obj){
			return null;
		}else {
			try {
				return (Date)obj;
			} catch (Exception e) {
				return null;
			}
		}
	}
	public static boolean getObjBoolean(Object obj){
		if(null == obj){
			return false;
		}else {
			try {
				return (Boolean)obj;
			} catch (Exception e) {
				return false;
			}
		}
	}
	public static BigDecimal getObjBigDecimal(Object obj, int scale){
		BigDecimal value = null;
		if(null == obj){
			return null;
		}else {
			try {
				value = new BigDecimal(obj.toString().trim().replace(",", ""));
				value = BigDecimalUtils.round(value, scale);
			} catch (Exception e) {
				value = null;
			}
		}
		return value;
	}
	public static BigDecimal getObjBigDecimal(Object obj){
		BigDecimal value = null;
		if(null == obj){
			return null;
		}else {
			try {
				value = new BigDecimal(obj.toString().trim().replace(",", ""));
			} catch (Exception e) {
				value = null;
			}
		}
		return value;
	}
	
	public static int getIntValue(Object obj, int defaultValue) {
		if (null == obj) return defaultValue;
		if (obj instanceof Integer) return (Integer) obj;
		try {
			return Integer.parseInt(obj.toString().trim());
		} catch (Exception e) {
			return defaultValue;
		}
	}
	
	public static double getDoubleValue(Object obj,double defaultValue){
		if (null == obj) return defaultValue;
		if (obj instanceof Double) return (Double) obj;
		try {
			return Double.parseDouble(obj.toString().trim());
		} catch (Exception e) {
			return defaultValue;
		}
	}
	
	public static float getFloatValue(Object obj, float defaultValue) {
		if (null == obj) return defaultValue;
		if (obj instanceof Float) return (Float) obj;
		try {
			return Float.parseFloat(obj.toString().trim());
		} catch (Exception e) {
			return defaultValue;
		}
	}
	
	public static boolean equals(String str1, String str2) {
		if (null != str1 && null != str2 && str1.equals(str2)) {
			return true;
		} else {
			return false;
		}
	}
	
	public static void main(String[] arges) {
		double score = 1.123456789;
		score = 8.3;
		NumberFormat df = NumberFormat.getInstance();
		df.setRoundingMode(RoundingMode.HALF_UP);
		df.setMaximumFractionDigits(3);
		System.out.println(df.format(score));
		BigDecimal bg = new BigDecimal("-1431.32156");
		df.setMaximumFractionDigits(-1);
		System.out.println(df.format(bg));
		
	}
}
