package com.gx.obe.util.utils;

import java.io.File;

import org.eclipse.swt.SWT;
import org.eclipse.swt.ole.win32.OLE;
import org.eclipse.swt.ole.win32.OleClientSite;
import org.eclipse.swt.ole.win32.OleFrame;
import org.eclipse.swt.widgets.Composite;

/**
 * @Description: 
 * @author guoyr
 */
public class OleClientSiteUtils {

	/**
	OLE.OLEIVERB_PRIMARY：打开编辑状态的OLE控件。
	◇ OLE.OLEIVERB_SHOW：显示OLE控件。
	◇ OLE.OLEIVERB_OPEN：在另外一个窗口中打开OLE控件。
	◇ OLE.OLEIVERB_HIDE：隐藏OLE控件。
	◇ OLE.OLEIVERB_INPLACEACTIVATE：不带有工具栏和菜单栏的方式。
	◇ OLE.OLEIVERB_UIACTIVATE：激活OLE的菜单栏和工具栏。
	◇ OLE.OLEIVERB_DISCARDUNDOSTATE：关闭OLE控件。
	**/
	
	private void createOleFram(Composite parent, File file)
    {
        //OleFrame实际上是一个Composite，用于放置OLE控件
        OleFrame oleFrame = new OleFrame(parent,SWT.NONE);
        
//       file = new File("E:/result.xls");
       //OleClientSite提供一个场所用于把OLE对象嵌入到容器中，在这里“Excel.Sheet”表示的OLE对象是Excel
       OleClientSite clientSite = new OleClientSite(oleFrame,SWT.NONE,file);
       //OleClientSite在显示OLE对象时所做的动作，这里的动作是OLEIVERB_SHOW，表示显示
        clientSite.doVerb(OLE.OLEIVERB_SHOW);
         
    }
}
