package com.gx.obe.util.utils;

import java.util.function.Function;
import java.util.function.Predicate;

/**
 * @author chenxw
 */
public class PredicateUtils {
	
	/**
	 * @Description: 取反
	 * @author chenxw
	 * @param predicate
	 * @return
	 */
	public static <T> Predicate<T> negate(Predicate<T> predicate) {
		return predicate.negate();
	}
	
	/**
	 * @Description: 转换
	 * @author chenxw
	 * @param function
	 * @param predicate
	 * @return
	 */
	public static <T, R> Predicate<T> map(Function<T, R> function, Predicate<R> predicate) {
		return t -> predicate.test(function.apply(t));
	}
	
	/**
	 * @Description: 大于
	 * @author chenxw
	 * @param higher
	 * @return
	 */
	public static Predicate<Integer> higher(int higher) {
		return t -> t > higher;
	}
	
	/**
	 * @Description: 小于
	 * @author chenxw
	 * @param lower
	 * @return
	 */
	public static Predicate<Integer> lower(int lower) {
		return t -> t < lower;
	}
	
}
