package com.gx.obe.util.utils;

import java.awt.Dimension;
import java.awt.Insets;
import java.awt.Toolkit;

import javax.swing.JFrame;

/**
 * @Description: 电脑屏幕尺寸获取工具类
 * @author guoyr
 */
public class ScreenUtils extends JFrame{

	private static final long serialVersionUID = 1L;

	/**
	 * @Description:获取当前电脑任务栏高度 
	 * @author guoyr
	 * @return
	 */
	public int getTaskBarHight(){
		Insets screenInsets = Toolkit.getDefaultToolkit().getScreenInsets(this.getGraphicsConfiguration());
		int taskBarHeight = screenInsets.bottom;
		return taskBarHeight;
	}

	/**
	 * @Description:获取电脑 屏幕高度 
	 * @author guoyr
	 * @return
	 */
	public int getScreenHight(){
		Dimension scrSize=Toolkit.getDefaultToolkit().getScreenSize(); 
		return scrSize.height;
	}

	/**
	 * @Description: 获取电脑屏幕宽度
	 * @author guoyr
	 * @return
	 */
	public int getScreenWight(){
		Dimension scrSize=Toolkit.getDefaultToolkit().getScreenSize(); 
		return scrSize.width;
	}
}
