package com.gx.obe.util.utils;

import java.math.BigDecimal;
import java.net.URL;
import java.util.LinkedHashMap;
import java.util.Map;
import java.util.Map.Entry;
import java.util.Set;

import javax.xml.namespace.QName;
import javax.xml.rpc.ParameterMode;

import org.apache.axis.client.Call;
import org.apache.axis.client.Service;
import org.apache.axis.encoding.XMLType;
public class ServiceUtils {
	String url;
	QName qName;
	LinkedHashMap<String, Object> parameters = new LinkedHashMap<>();
	public ServiceUtils(String url) {
		this.url = url;
	}
	public void setOperationName(String nameSpage, String name) {
		qName = new QName(nameSpage, name); 
	}
	
	public void addParameter(String parameter, Object value) {
		parameters.put(parameter, value);
	}

	public Object call(Class<?> classType) {
		try {
			Service service = new Service();
			Call call = (Call)service.createCall();
			//设置url
			call.setTargetEndpointAddress(new URL(url));
			call.setUseSOAPAction(true);
			// TODO地址写到配置文件中
			call.setOperationName(qName);
			//设置返回值类型，这里返回的list
			call.setReturnClass(classType);
//		call.setReturnClass(String.class);
			call.setEncodingStyle("UTF-8");
			//设置输入参数，addParameter("参数名",xml对应的参数类型,入参)
//		call.addParameter("roomName", XMLType.XSD_STRING, ParameterMode.IN);
//		call.addParameter("maxUserCount", XMLType.XSD_INTEGER, ParameterMode.IN);
			Set<Entry<String, Object>>  parametersSets = parameters.entrySet();
			Object[] param = new Object[parametersSets.size()];
			int index = 0;
			for (Map.Entry<String, Object> entry : parameters.entrySet()){
				System.out.println("key: " + entry.getKey() + ", value: " + entry.getValue());
				Object paramValue = entry.getValue();
				if(null != paramValue) {
					if(paramValue instanceof String) {
						call.addParameter(entry.getKey(), XMLType.XSD_STRING, ParameterMode.IN);
					}else if(paramValue instanceof Integer) {
						call.addParameter(entry.getKey(), XMLType.XSD_INTEGER, ParameterMode.IN);
					}else if(paramValue instanceof Boolean) {
						call.addParameter(entry.getKey(), XMLType.XSD_BOOLEAN, ParameterMode.IN);
					}else if(paramValue instanceof BigDecimal) {
						call.addParameter(entry.getKey(), XMLType.XSD_DECIMAL, ParameterMode.IN);
					}else if(paramValue instanceof Double) {
						call.addParameter(entry.getKey(), XMLType.XSD_DOUBLE, ParameterMode.IN);
					}else {
						call.addParameter(entry.getKey(), XMLType.XSD_STRING, ParameterMode.IN);
					}
//		    	Class<?> nativeType = paramValue.getClass();
//		    	if ((nativeType == int.class || nativeType == Integer.class)
//				}
				}else {
					call.addParameter(entry.getKey(), XMLType.XSD_STRING, ParameterMode.IN);
				}
				param[index] = entry.getValue();
				index ++;
			}
			//得到的返回值
			return call.invoke(param);
		} catch (Exception e) {
		}
		return null;
	}
	
}

