package com.gx.obe.util.utils;
import net.sourceforge.pinyin4j.PinyinHelper;
import net.sourceforge.pinyin4j.format.HanyuPinyinCaseType;
import net.sourceforge.pinyin4j.format.HanyuPinyinOutputFormat;
import net.sourceforge.pinyin4j.format.HanyuPinyinToneType;
import net.sourceforge.pinyin4j.format.HanyuPinyinVCharType;
import net.sourceforge.pinyin4j.format.exception.BadHanyuPinyinOutputFormatCombination;

public class SpellHelper {
     
    /**
     * @Description: 将中文转换为英文
	 * @author guoyr
	 * @author guoyr
	 * @author guoyr
	 * @author guoyr
     * @param name
     * @return
     */
    public static String getEname(String name) {
          HanyuPinyinOutputFormat pyFormat = new HanyuPinyinOutputFormat();
          pyFormat.setCaseType(HanyuPinyinCaseType.LOWERCASE);    //设置样式
          pyFormat.setToneType(HanyuPinyinToneType.WITHOUT_TONE);
           pyFormat.setVCharType(HanyuPinyinVCharType.WITH_V);
           StringBuilder pingying = new StringBuilder();
          try {
//        	 String temp = PinyinHelper.toHanyuPinyinString(name, pyFormat, "");
//        	 System.out.println(temp);
        	  for(char charName : name.toCharArray()){
        		  String _name = getFirstHanyuPinyinString(PinyinHelper.toHanyuPinyinStringArray(charName, pyFormat));
        		  // 解决非中文转换为“”如果为非中文，则直接使用
        		  pingying.append("".equals(_name)?charName:_name);
//        		  pingying.append(concatPinyinStringArray(PinyinHelper.toHanyuPinyinStringArray(charName, pyFormat)));
        	  }
		} catch (BadHanyuPinyinOutputFormatCombination e) {
		}
		return pingying.toString();
     }
    
    /**
     * @Description: 获得第一个汉语评音
	 * @author guoyr
	 * @author guoyr
	 * @author guoyr
	 * @author guoyr
     * @param pinyinArray
     * @return
     */
    private static String getFirstHanyuPinyinString(String[] pinyinArray){
    	if ((null != pinyinArray) && (pinyinArray.length > 0)){
    		return pinyinArray[0];
    	}else {
    		return "";
    	}
    }
    
    /**
     * @Description: 返回所有评音（多音字或多个音符时会返回多个）
	 * @author guoyr
	 * @author guoyr
	 * @author guoyr
	 * @author guoyr
     * @param pinyinArray
     * @return
     */
    private static String concatPinyinStringArray(String[] pinyinArray)
    {
        StringBuffer pinyinStrBuf = new StringBuffer();

        if ((null != pinyinArray) && (pinyinArray.length > 0))
        {
            for (int i = 0; i < pinyinArray.length; i++)
            {
                pinyinStrBuf.append(pinyinArray[i]);
            }
        }
        String outputString = pinyinStrBuf.toString();
        return outputString;
    }
     
    /**
     * @Description: 姓、名 英文第一个字母大写
	 * @author guoyr
	 * @author guoyr
	 * @author guoyr
	 * @author guoyr
     * @param name
     * @return
     */
    public static String getUpEname(String name) {
          char[] strs = name.toCharArray();
          String newname = null;
 
           if (strs.length == 2) {    //如果姓名只有两个字
                newname = toUpCase(getEname("" + strs[0])) + " " + toUpCase(getEname("" + strs[1]));
            } else if (strs.length == 3) {    //如果姓名有三个字
                newname = toUpCase(getEname("" + strs[0])) + " "+ toUpCase(getEname("" + strs[1] + strs[2]));
            } else if (strs.length == 4) {    //如果姓名有四个字
                newname = toUpCase(getEname("" + strs[0] + strs[1])) + " "+ toUpCase(getEname("" + strs[2] + strs[3]));
          } else {
                 newname = toUpCase(getEname(name));
          }

          return newname;
     }

      //首字母大写
     private static String toUpCase(String str) {
          StringBuffer newstr = new StringBuffer();
          newstr.append((str.substring(0, 1)).toUpperCase()).append(
          str.substring(1, str.length()));

          return newstr.toString();
     }

     public static void main(String[] args) {
          System.out.println(getUpEname("郭 永 荣"));
//          System.out.println(getUpEname("王五"));
          System.out.println(getEname("郭永荣"));
          System.out.println(SpellHelper.getEname("测试专家1"));
          System.out.println(SpellHelper.getEname("测试专家12"));
          System.out.println(SpellHelper.getEname("测试专家13"));
     }

} 
